#!/usr/bin/env python3
# -*- coding: utf-8 -*-

import sys

def generate_instance(num_coins):
    problemfile = "prob%02d.pddl" % num_coins
    pf = open(problemfile, "w")

    lines = []
    problem_name = "coinFlip%02d" % num_coins
    coin_list = ["c%d" % r for r in range(1,num_coins+1)]

    lines.append("(define (problem %s)" % problem_name)
    lines.append("  (:domain coinFlip)")
    lines.append("  (:objects %s - coin)" % (" ".join(coin_list),))
    lines.append("  (:init")
    for c in coin_list:
        lines.append("         (stands %s)" % c)
    lines.append("   )")
    lines.append("  (:goal (and")
    for c in coin_list:
        lines.append("         (heads %s)" % c)
    lines.append("         )")
    lines.append("  )")
    lines.append(")")

    for line in lines:
        print(line, file=pf)
    pf.flush()
    pf.close()

if __name__ == '__main__':
    try:
        num_coins = int(sys.argv[1])
        assert num_coins >= 1
    except (IndexError, AssertionError):
        print("ERROR: %s expects the number of coins (a positive integer) as the first argument." % sys.argv[0])
        print("       Setting number of coins to 1.")
        num_coins = 1
        
    generate_instance(num_coins)
